;    ᭮ ணࠬ

; "  POCSAG"

; 뭥ᥭ  ⤥ 䠩 ⮫쪮  㤮⢠ ࠡ
;  ᭮ 㫥 - rxpocsag.asm





;*******************************************************************
;        ணࠬ 뢮 ଠ樨                                         *
;*******************************************************************

;*******************************************************************
;*SendChar - Sends character to LCD                                *
;*This routine splits the character into the upper and lower       * 
;*nibbles and sends them to the LCD, upper nibble first.           *
;*******************************************************************
;
Send_Char
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready
	bsf  __rslcd		; Set LCD to data mode

Char_to_lcd
	bcf  __rwlcd	; Set LCD to write
	call setreg

	movf    Char,w          
	movwf PORTB
	call PBOUT

	bsf  _elcd	; toggle E for LCD
	bcf  _elcd

	swapf   Char,W
	movwf PORTB

	bsf _elcd    ; toggle E for LCD
	bcf _elcd

	bsf  __rslcd	; Set LCD to data mode
	bsf  __rwlcd	; Set LCD to read
	call setreg
	return

;*******************************************************************
;* Send_Cmd - Sends command to LCD                                 *
;* This routine splits the command into the upper and lower        * 
;* nibbles and sends them to the LCD, upper nibble first.          *
;*******************************************************************

Send_Cmd
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready

	bcf  __rslcd	; Set LCD to command mode
	goto Char_to_lcd

;*******************************************************************
;* This routine checks the busy flag, returns when not busy        *
;*  Affects:                                                       *
;*      Temp - Returned with busy/address                          *
;*******************************************************************
;   ਣ 뫠 訡! - ࠢ

Wait_Busy
	bcf     __rslcd ; Set LCD for Command mode
	bsf     __rwlcd ; Setup to read busy flag
	call setreg	; PB - in, after setreg

	bsf     _elcd    ; Set E high
	movf    PORTB,w  ; Read upper nibble busy flag, DDRam address
	bcf     _elcd    ; Set E low

	andlw   0xF0     ; Mask out lower nibble
	movwf   Temp

	bsf     _elcd    ; Toggle E to get lower nibble
	swapf   PORTB,w  ; Read lower nibble busy flag, DDRam address
	bcf     _elcd

	andlw   0x0F            ; Mask out upper nibble
	iorwf   Temp,f          ; Combine nibbles, RES in Temp !!!!!!!!!!!!!!!
	btfsc   Temp, 7         ; Check busy flag, high = busy
	goto    Wait_Busy       ; If busy, check again

	return



; ================================
;    樠  
; ================================
;
LCD_Init

	bcf     _elcd	   ; ⨬  ࠢ騥 
	bcf     __rslcd
	bcf     __rwlcd
	call setreg	   ;   ᯮ⥫ ॣ (5616)	
	call    delay20	   ; Wait for 15ms for LCD to get powered up

	movlw   0x030      ; Command for 4-bit interface high nibble
	movwf   PORTB    ; Send data to LCD      
	call PBOUT

	bsf     _elcd	; clock to write to lcd
	bcf     _elcd
	call    delay20		; Delay for at least 4.1ms before continuing

	bsf     _elcd
	bcf     _elcd

;	call    d100mks        ; delay for at least 100usec before continuing
	call    delay20        ; delay for at least 100usec before continuing

	bsf     _elcd	     ; Clock the initalize command to LCD module
	bcf     _elcd

	call    Wait_Busy  ; From here on, the Busy Bit will be valid.

	movlw   0x020  ; Command for 4-bit interface high nibble (Really an 8bit command but
		       ; lower 4 bits are don't care at this point)
	movwf   PORTB  ; Send data to LCD      
	call PBOUT

	bsf     _elcd	     ; Clock the initalize command to LCD module
	bcf     _elcd
	
 movlw FUNCTION_SET ; function set command 4-bit I/F, Font, Number of lines
 call  Send_Cmd     ; Can now use the Send_Cmd routine
		    ; since Busy Bit Valid and in 4bit mode.

;	movlw   DISP_OFF
;	call    Send_Cmd
	movlw   DISP_ON_B	; _B
	goto    Send_Cmd

; LCD Module is now initalized

