;    ᭮ ணࠬ

; "  POCSAG"

; 뭥ᥭ  ⤥ 䠩 ⮫쪮  㤮⢠ ࠡ
;  ᭮ 㫥 - rxpocsag.asm



        LIST
; P16F84.INC  Standard Header File, Version 2.00    Microchip Technology, Inc.
        NOLIST

; This header file defines configurations, registers, and other useful bits of
; information for the PIC16F84 microcontroller.  These names are taken to match 
; the data sheets as closely as possible.  

; Note that the processor must be selected before this file is 
; included.  The processor may be selected the following ways:

;       1. Command line switch:
;               C:\ MPASM MYFILE.ASM /PIC16F84
;       2. LIST directive in the source file
;               LIST   P=PIC16F84
;       3. Processor Type entry in the MPASM full-screen interface

;==========================================================================
;
;       Revision History
;
;==========================================================================

;Rev:   Date:    Reason:

;2.00   07/24/96 Renamed to reflect the name change to PIC16F84.
;1.01   05/17/96 Corrected BADRAM map
;1.00   10/31/95 Initial Release

;==========================================================================
;
;       Verify Processor
;
;==========================================================================

        IFNDEF __16F84
           MESSG "Processor-header file mismatch.  Verify selected processor."
        ENDIF

;==========================================================================
;
;       Register Definitions
;
;==========================================================================

W                            EQU     H'0000'
F                            EQU     H'0001'

;----- Register Files------------------------------------------------------

INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
EEDATA                       EQU     H'0008'
EEADR                        EQU     H'0009'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'

OPTION_REG                   EQU     1	;	H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
EECON1                       EQU     H'0088'
EECON2                       EQU     H'0089'

;----- STATUS Bits --------------------------------------------------------

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

GIE                          EQU     H'0007'
EEIE                         EQU     H'0006'
T0IE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
T0IF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'

;----- OPTION Bits --------------------------------------------------------

NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
T0CS                         EQU     H'0005'
T0SE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'

;----- EECON1 Bits --------------------------------------------------------

EEIF                         EQU     H'0004'
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM H'CF'
        __BADRAM H'07', H'50'-H'7F', H'87'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_CP_ON                       EQU     H'000F'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_PWRTE_OFF                   EQU     H'3FFF'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'

        LIST


	NOLIST

;******************* PIC16c5X/16cXX Registers *******************
;
; Define Reset Vectors
PIC54   equ     1FFh
PIC55   equ     1FFh
PIC56   equ     3FFh
PIC57   equ     7FFh
PIC71   equ     0
PIC84	equ     0
;
; Data Registers
RTCC    equ     1
rtcc    equ     1
tmr0	equ 	1
PC      equ     2
PCL      equ     2
pc      equ     2
STATUS  equ     3
status  equ     3
FSR     equ     4
fsr     equ     4
PORTA	equ     5
porta	equ     5
PORTB	equ     6
portb	equ     6
PORTC	equ     7
portc	equ     7
;
Port_A  equ     5
port_a  equ     5
Port_B  equ     6
port_b  equ     6
Port_C  equ     7
;
; 16c71 Special-purpose registers
ADRES   equ     9
ADCON0  equ     8
ADCON1  equ     88h

PCLATH  equ     0Ah
pclath  equ     0Ah

INTCON  equ     0Bh
intcon  equ     0Bh

TRISA   equ     85h 
trisa   equ     85h 

TRISB   equ     86h 
trisb   equ     86h 
;
; 16c84 Special-purpose registers
EEDATA  equ     8
EEADR   equ     9
EECON1  equ     88h
EECON2  equ     89h


rd 	equ 0
wr 	equ 1
wren 	equ 2
wrerr	equ 3
eeif	equ 4

; Status File Register Bits
CARRY   equ     0
C       equ     0
DCARRY  equ     1
DC      equ     1
Z_bit   equ     2
Z       equ     2
P_DOWN  equ     3
PD      equ     3
T_OUT   equ     4
TO      equ     4

; 16c5x status bits
PA0     equ     5
PA1     equ     6   
PA2     equ     7 
;
; 16c71 status bits
RP0     equ     5
rp0     equ     5

RP1     equ     6   
rp1     equ     6   

IRP     equ     7

; 16c71 INTCON register bits
GIE     equ     7
ADIE    equ     6
RTIE    equ     5
INTE    equ     4
RBIE    equ     3
RTIF    equ     2
rtif    equ     2

INTF    equ     1
RBIF    equ     0

; 16c71 ADCON0 register bits
ADCS1   equ     7
ADCS0   equ     6
CHS1    equ     4
CHS0    equ     3
GO      equ     2
ADIF    equ     1
ADON    equ     0

; 16c71 ADCON1 register bits
PCFG1   equ     1
PCFG0   equ     0
;
; Misc. variables
Same    equ     1
LSB     equ     0
MSB     equ     7
TRUE    equ     1
YES     equ     1
FALSE   equ     0
NO      equ     0
;
;*************************************************************************

	LIST